#include <qfiledialog.h>
#include <qmessagebox.h>

#include "planche.h"

void planche :: initialisePlanche(int pourcent, bool withoutBug, bool activatedProgression )
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 int i,j,err,bary,bary2 ;
 int* t ;
 time_t rand_germe ;


 rand_germe = time(NULL) ;
 //rand_germe = 7 ;
 rand_germe *= rand_germe+2 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((int) rand_germe ) ;
 switch (pourcent)
	{
	 case 0   : for(i=0;i<sizeX;i++) old[i] = 1 ; break ;
	 case 100 : for(i=0;i<sizeX;i++) old[i] = 0 ; break ;
	 default  : pourcent++ ;
	 	    for(i=0;i<sizeX;i++) if ((rand() % pourcent)==0) old[i] = 1 ; else old[i] = 0 ;
	}

 if (activatedProgression)
	{
	 _progressD = new QProgressDialog( this,"_progessD") ;
	 _progressD->setTotalSteps( sizeY-1 ) ;
	}


 windowpainter.begin( this ) ;
 bufferpainter.begin( &_buffer ) ;
 windowpainter.setPen( QColor(0,0,0) ) ;
 bufferpainter.setPen( QColor(0,0,0) ) ;
 for(i=0;i<sizeX;i++)
	{
	 if (old[i]==0) continue ;
	 windowpainter.drawPoint(i,0) ;
	 bufferpainter.drawPoint(i,0) ;
	}

 if (withoutBug)
 {
  for(j=1;j<sizeY;j++)
	{
	 current[0] = appli[16*old[sizeX-2]+8*old[sizeX-1]+4*old[0]+2*old[1]+old[2]] ;
	 current[1] = appli[16*old[sizeX-1]+8*old[0]+4*old[1]+2*old[2]+old[3]] ;
	 for(i=2;i<sizeX-2;i++)
	 	 current[i] = appli[16*old[i-2]+8*old[i-1]+4*old[i]+2*old[i+1]+old[i+2]] ;

	 current[sizeX-2] = appli[16*old[sizeX-4]+8*old[sizeX-3]+4*old[sizeX-2]+2*old[sizeX-1]+old[0]] ;
	 current[sizeX-1] = appli[16*old[sizeX-3]+8*old[sizeX-2]+4*old[sizeX-1]+2*old[0]+old[1]] ;

	 t = old ;
	 old = current ;
	 current = t ;
	 for(i=0;i<sizeX;i++)
		{
		 if (old[i]==0) continue ;
		 windowpainter.drawPoint(i,j) ;
		 bufferpainter.drawPoint(i,j) ;
		}
	  if (activatedProgression) _progressD->setProgress(j) ;
	}
 }
 else
 {
  for(j=1;j<sizeY;j++)
	{
	 current[0] = appli[16*old[sizeX-2]+8*old[sizeX-1]+4*old[0]+2*old[1]+old[2]] ;
	 current[1] = appli[16*old[sizeX-1]+8*old[0]+4*old[1]+2*old[2]+old[3]] ;

	 // bug
	 for(i=2;i<sizeX-2;i++)
		{
		 err = rand() % 50 ;
		 if (err==0)
			{
			 bary  = rand() % 5 ;
			 bary2 = rand() % 5 ;
			 current[i] = appli[16*old[i+bary2-2]+8*old[i-1]+4*old[i]+2*old[i+1]+old[i+bary-2]] ;
			}
		 	else current[i] = appli[16*old[i-2]+8*old[i-1]+4*old[i]+2*old[i+1]+old[i+2]] ;

		}


	 current[sizeX-2] = appli[16*old[sizeX-4]+8*old[sizeX-3]+4*old[sizeX-2]+2*old[sizeX-1]+old[0]] ;
	 current[sizeX-1] = appli[16*old[sizeX-3]+8*old[sizeX-2]+4*old[sizeX-1]+2*old[0]+old[1]] ;

	 t = old ;
	 old = current ;
	 current = t ;
	 for(i=0;i<sizeX;i++)
		{
		 if (old[i]==0) continue ;
		 windowpainter.drawPoint(i,j) ;
		 bufferpainter.drawPoint(i,j) ;
		}
	 if (activatedProgression) _progressD->setProgress(j) ;
	}
 }

 windowpainter.end() ;
 bufferpainter.end() ;

 if (activatedProgression)
	{
	 delete _progressD ;
	}

}


planche :: planche()
{
 long i ;

 setBackgroundMode( NoBackground ) ;
 setFocusPolicy(QWidget::StrongFocus) ;
 sizeX = SIZE_X ;
 sizeY = SIZE_Y ;
 withoutBug = true ;
 for(i=0;i<32;i++) appli[i] = 0 ;
 appli[1]  = 1 ;
 appli[3]  = 1 ;
 appli[4]  = 1 ;
 appli[6]  = 1 ;
 appli[7]  = 1 ;
 appli[9]  = 1 ;
 appli[10] = 1 ;
 appli[12] = 1 ;
 appli[13] = 1 ;
 appli[15] = 1 ;
 appli[16] = 1 ;
 appli[18] = 1 ;
 appli[19] = 1 ;
 appli[21] = 1 ;
 appli[22] = 1 ;
 appli[24] = 1 ;
 appli[25] = 1 ;
 appli[28] = 1 ;
 appli[30] = 1 ;

 old     = new int[SIZE_X] ;
 current = new int[SIZE_X] ;

 _buffer.resize( SIZE_X ,SIZE_Y ) ;
 _buffer.fill() ;

 bitBlt( this , 0 , 0 , &_buffer ) ;

 initialisePlanche( 1,withoutBug,true ) ;

 resize( QSize(SIZE_X, SIZE_Y) );
}

planche :: ~planche()
{
 delete old ;
 delete current ;
}

void planche :: setParameters(unsigned long a)
{
 int i ;

 for(i=0;i<32;i++)
	{
	 if ((a&1)==1) appli[i]=1 ; else appli[i] = 0 ;
	 a >>= 1 ;
	}
}

void planche :: restart(int pour, unsigned long a,bool withoutBuggy )
{
 pourcentage  = pour ;
 withoutBug = withoutBuggy ;
 _buffer.fill() ;
 bitBlt( this , 0 , 0 , &_buffer ) ;

 setParameters(a) ;
 initialisePlanche( pour,withoutBuggy,false ) ;
}

void planche :: setBug(bool b)
{
 withoutBug = b ;
}

void planche :: sizeChanged(int r)
{
 switch(r)
	{
	 case 0 : sizeX = 511 ; sizeY = 128 ; break ;
	 case 1 : sizeX = 1031 ; sizeY = 256 ; break ;
	 case 2 : sizeX = 2053 ; sizeY = 512 ; break ;
	 case 3 : sizeX = 3989 ; sizeY = 1024 ; break ;
	 case 4 : sizeX = 8209 ; sizeY = 2048 ; break ;
	 case 5 : sizeX = 16411 ; sizeY = 4096 ; break ;
	 default : sizeX = 1031 ; sizeY = 256 ;
	}

 //cout << " sizeX = " << sizeX << " sizeY = "  << sizeY << endl ;
 resize( sizeX, sizeY );
 delete old ;
 delete current ;
 old = new int[sizeX] ;
 current = new int[sizeX] ;
 _buffer.fill() ;
 bitBlt( this , 0 , 0 , &_buffer ) ;
 initialisePlanche( pourcentage,withoutBug,false ) ;
}

/*
void planche :: random(bool symm )
{
 int i ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+2 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((int) rand_germe ) ;

 for(i=0;i<16;i++) appli[i] = rand() & 1 ;

 if (symm) for(i=16;i<32;i++) appli[i] = appli[31-i] ;
	else for(i=16;i<32;i++) appli[i] = rand() & 1 ;
}*/

void planche :: calculate()
{
 QPainter ipainter ;
 int i,j,err,bary,bary2 ;
 int* t ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+2 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((int) rand_germe ) ;


 ipainter.begin( &_buffer ) ;

 if (withoutBug)
 {
  for(j=0;j < SPEED;j++)
	{
	 bitBlt( this , 0 , 0 , &_buffer , 0 , 1 , sizeX , sizeY-1 ) ;
	 bitBlt( &_buffer , 0 , 0 , &_buffer , 0 , 1 , sizeX , sizeY-1 ) ;


	 current[0] = appli[16*old[sizeX-2]+8*old[sizeX-1]+4*old[0]+2*old[1]+old[2]] ;
	 current[1] = appli[16*old[sizeX-1]+8*old[0]+4*old[1]+2*old[2]+old[3]] ;

	 //bug
	 //for(i=2;i<SIZE_X-2;i++)
	//	 current[i] = appli[16*old[i-2]+8*old[i-1]+4*old[i]+2*old[i+1]+old[i+1]] ;
	 for(i=2;i<sizeX-2;i++)
		 current[i] = appli[16*old[i-2]+8*old[i-1]+4*old[i]+2*old[i+1]+old[i+2]] ;


	 current[sizeX-2] = appli[16*old[sizeX-4]+8*old[sizeX-3]+4*old[sizeX-2]+2*old[sizeX-1]+old[0]] ;
	 current[sizeX-1] = appli[16*old[sizeX-3]+8*old[sizeX-2]+4*old[sizeX-1]+2*old[0]+old[1]] ;

	 t = old ;
	 old = current ;
	 current = t ;

	 for(i=0;i<sizeX;i++)
		{
		 if (old[i]==0) ipainter.setPen( QColor(255,255,255) ) ;
			else ipainter.setPen( QColor(0,0,0) ) ;
		 ipainter.drawPoint(i,sizeY-1) ;
		}
	}
 }
 else
 {
  for(j=0;j<SPEED;j++)
	{
	 bitBlt( this , 0 , 0 , &_buffer , 0 , 1 , SIZE_X , SIZE_Y-1 ) ;
	 bitBlt( &_buffer , 0 , 0 , &_buffer , 0 , 1 , SIZE_X , SIZE_Y-1 ) ;

	 current[0] = appli[16*old[sizeX-2]+8*old[sizeX-1]+4*old[0]+2*old[1]+old[2]] ;
	 current[1] = appli[16*old[sizeX-1]+8*old[0]+4*old[1]+2*old[2]+old[3]] ;

	 //bug
	 for(i=2;i<sizeX-2;i++)
		{
		 err = rand() % 50 ;
		 if (err==0)
			{
			 bary  = rand() % 5 ;
			 bary2 = rand() % 5 ;
			 current[i] = appli[16*old[i+bary2-2]+8*old[i-1]+4*old[i]+2*old[i+1]+old[i+bary-2]] ;
			}
		 	else current[i] = appli[16*old[i-2]+8*old[i-1]+4*old[i]+2*old[i+1]+old[i+2]] ;

		}


	 current[sizeX-2] = appli[16*old[sizeX-4]+8*old[sizeX-3]+4*old[sizeX-2]+2*old[sizeX-1]+old[0]] ;
	 current[sizeX-1] = appli[16*old[sizeX-3]+8*old[sizeX-2]+4*old[sizeX-1]+2*old[0]+old[1]] ;


	 t = old ;
	 old = current ;
	 current = t ;

	 for(i=0;i<sizeX;i++)
		{
		 if (old[i]==0) ipainter.setPen( QColor(255,255,255) ) ;
			else ipainter.setPen( QColor(0,0,0) ) ;

		 ipainter.drawPoint(i,sizeY-1) ;
		}
	}
 }

 ipainter.end() ;
 ipainter.begin( this ) ;
 for(i=0;i<sizeX;i++)
	{
	 if (old[i]==0) ipainter.setPen( QColor(255,255,255) ) ;
		else ipainter.setPen( QColor(0,0,0) ) ;
	 ipainter.drawPoint(i,sizeY-1) ;
	}
 ipainter.end() ;
}

void planche :: saveImage()
{
 int i ;

 QString filename = QFileDialog::getSaveFileName(".",".bmp", this ) ;
 if (!filename.isEmpty())
	{
	 if ( !_buffer.save( filename+".bmp", "BMP") )
 		QMessageBox::warning(0,"Erreur d'enregistrement" ,
					"impossible d'enregistrer le fichier") ;
	 QFile file( filename+".txt" ) ;
	 if (file.open( IO_WriteOnly ))
		{
		 QTextStream stream( &file ) ;
		 for(i=0;i<32;i++)
			stream << " appli[" << i << "] = " << appli[i] << endl ;
		 file.close() ;
		}
	}
}

void planche :: keyPressEvent( QKeyEvent* event )
{
 int rep ;

 rep = event->key() ;
 if (rep == Qt::Key_Space )
	{
	 calculate() ;
	}
 if (rep == Qt::Key_S )
	{
	 //releaseKeyboard() ;
	 saveImage() ;
	 //grabKeyboard() ;
	}

}

void planche :: paintEvent( QPaintEvent* event )
{
 //cout << "\n paintEvent" ;
 bitBlt( this , 0 , 0 , &_buffer ) ;
}

/*
void planche :: slotLoadAppli(int* a,int nbConfig,int nbV )
{
 int i ;

 if (nbV != nbVoisins)
	{
	 delete appli ;
	 appli = new int[nbConfig] ;
	 nbVoisins = nbV ;
	}
 for(i=0;i<nbConfig;i++) appli[i] = a[i] ;
}
*/

void planche :: closeEvent( QCloseEvent* e )
{
 e->ignore() ;
}

